import wsgiref.handlers, urlparse
from google.appengine.ext import webapp
from google.appengine.api import urlfetch

class MainPage(webapp.RequestHandler):
    def post(self):
    	headers={'Content-Type':'application/xml'}
        data = urlfetch.fetch('http://server4.operamini.com', payload=self.request.body, method=urlfetch.POST, headers=headers)
        self.response.status = data.status_code
        self.response.headers.add_header('Content-Type', 'application/octet-stream')
        self.response.headers.add_header('Cache-Control', 'private, no-cache')
        self.response.out.write(data.content)
    
    def get(self):
        self.response.status = '200 OK'
        self.response.headers.add_header('Content-Type', 'text/html')
        self.response.out.write('This is Opera Mini Server Proxy!')

def main():
    application = webapp.WSGIApplication( [(r'/.*', MainPage)], debug=True)
    wsgiref.handlers.CGIHandler().run(application)

if __name__ == "__main__":
    main()
